<?php

require_once 'activitytabs.civix.php';
use CRM_Activitytabs_ExtensionUtil as E;

/**
 * Implements hook_civicrm_config().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_config
 */
function activitytabs_civicrm_config(&$config) {
  _activitytabs_civix_civicrm_config($config);
}

/**
 * Implements hook_civicrm_install().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_install
 */
function activitytabs_civicrm_install() {
  // Create our setting.
  Civi::settings()->set('activitytabs', '[]');
  _activitytabs_civix_civicrm_install();
}

/**
 * Implements hook_civicrm_uninstall().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_uninstall
 */
function activitytabs_civicrm_uninstall() {

  // This looks the closest thing to 'delete'?
  Civi::settings()->revert('activitytabs');

}

/**
 * Implements hook_civicrm_enable().
 *
 * @link http://wiki.civicrm.org/confluence/display/CRMDOC/hook_civicrm_enable
 */
function activitytabs_civicrm_enable() {
  _activitytabs_civix_civicrm_enable();
}

function activitytabs_civicrm_navigationMenu(&$menu) {
  _activitytabs_civix_insert_navigation_menu(
    $menu,
    'Administer/Customize Data and Screens',
    [
      'label'      => E::ts('Activity Tabs'),
      'name'       => 'activity_tabs_config',
      'url'        => 'civicrm/a/#/activitytabs',
      'permission' => 'administer CiviCRM',
      'attributes' => [],
      'operator'   => 'OR',
      'separator'  => 0,
    ]
  );
}

/**
 * Implmements hook_civicrm_tabset
 *
 * @see https://docs.civicrm.org/dev/en/latest/hooks/hook_civicrm_tabset/
 */
function activitytabs_civicrm_tabset($tabsetName, &$tabs, $context) {
  if ($tabsetName == 'civicrm/contact/view') {
    foreach (CRM_ActivityTab::getConfigForAllTabs() as $atab) {
      $tabs[] = CRM_ActivityTab::createFromConfig($atab)
        ->getTabSetDefinition((int) $context['contact_id']);
    }
  }
}
